#include <iostream>
#include <cstring>
using namespace std;

int main()
{

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int N,M,Q;
    cin >> N >> M;
    int a[N][M];
    for(int i=0; i<N; i++)
        for(int j=0; j<M; j++)
            cin >> a[i][j];
    cin >> Q;
    int b[2][Q];
    long long rez[Q];
    memset(rez, 0, sizeof(rez));
    for(int i=0; i<Q; i++)
    {
        cin >> b[0][i] >> b[1][i];
        b[0][i]--;
        b[1][i]--;
    }
    long long pom;
    for(int k=0; k<Q; k++)
    {
        rez[k]=9223372036854775807;
        if(b[0][k]==0)
        {
            for(int i=0; i<b[1][k]; i++)
            {
                pom=0;
                for(int j=i; j>=0; j--)
                    pom+=a[0][j];
                for(int j=i; j<M; j++)
                    pom+=a[1][j];
                rez[k]=min(rez[k],pom);
            }
        }
        else
        {
            for(int i=b[1][k]+1; i<M; i++)
            {
                pom=0;
                for(int j=i; j>=0; j--)
                    pom+=a[0][j];
                for(int j=i; j<M; j++)
                    pom+=a[1][j];
                rez[k]=min(rez[k],pom);
            }
        }
    }
    for(int i=0; i<Q; i++)
        cout << rez[i] << endl;


    return 0;
}